package com.engine.salary.mapper.salaryacct;

import com.engine.salary.common.LocalDateRange;
import com.engine.salary.entity.salaryacct.po.SalaryAcctRecordPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Set;

public interface SalaryAcctRecordMapper {

	/**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
	List<SalaryAcctRecordPO> listAll();
    
    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
	 * @param salaryAcctRecord
     */
    List<SalaryAcctRecordPO> listSome(SalaryAcctRecordPO salaryAcctRecord);
    

	/**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
	SalaryAcctRecordPO getById(Long id);
	
	/**
     * 新增，忽略null字段
     *
     * @param salaryAcctRecord 新增的记录
     * @return 返回影响行数
     */
	int insertIgnoreNull(SalaryAcctRecordPO salaryAcctRecord);
	
	/**
     * 修改，修改所有字段
     *
     * @param salaryAcctRecord 修改的记录
     * @return 返回影响行数
     */
	int update(SalaryAcctRecordPO salaryAcctRecord);
	
	/**
     * 修改，忽略null字段
     *
     * @param salaryAcctRecord 修改的记录
     * @return 返回影响行数
     */
	int updateIgnoreNull(SalaryAcctRecordPO salaryAcctRecord);
	
	/**
     * 删除记录
     *
     * @param salaryAcctRecord 待删除的记录
     * @return 返回影响行数
     */
	int delete(SalaryAcctRecordPO salaryAcctRecord);

	/**
	 * 批量删除
	 *
	 * @param ids
	 */
	void deleteByIds(@Param("ids") Collection<Long> ids);

	List<SalaryAcctRecordPO> listByCreateDate(@Param(value = "createRange") LocalDateRange createRange, @Param(value = "salarySobIds") Set<Long> salarySobIds);

	void updateLockSalaryItemIds(SalaryAcctRecordPO salaryAcctRecord);

    List<SalaryAcctRecordPO> getBackCalcRecordByIds(@Param("collection") Set<Long> salaryAcctIds);
}